# print_string_x86.s

# Syscalls
.equ SYSCALL_EXIT,     60
.equ SYSCALL_WRITE,    1

# Other definitions
.equ STDOUT,	       1

        .globl _start
_start:
	mov	$hello,%rax
	call	print_string		# Print Hello World
	mov	$mystery,%rax
	call	print_string		# Print Goodbye
	mov	$goodbye,%rax
	call	print_string		# Print Goodbye


        #================================
        # Exit
        #================================
exit:
	mov	$5,%rdi
        mov     $SYSCALL_EXIT,%rax	# put exit syscall number (1) in eax
        syscall				# and exit


	#====================
	# print string
	#====================
	# Null-terminated string to print pointed to by %eax
	# %eax is trashed by this routine

print_string:
	push	%rbx	# Save registers on stack
	push	%rcx
	push	%rdx
	push	%rsi

	mov	%rax,%rsi		# String to print is arg3 (%rsi)
	mov	$SYSCALL_WRITE,%rax	# Syscall number goes in %rax
	mov	$STDOUT,%rdi		# Destination fd is arg1 (%rdi)

	# Now we need the length in %edx
	xor	%rdx,%rdx		# Set %edx to 0
	mov	%rsi,%rcx
count_loop:
	cmpb	$0,(%rcx)
	je	zero			# If zero, we are done

	inc	%rdx			# Otherwise increase length count
	inc	%rcx			# increment pointer

	jmp	count_loop		# And continue in loop

zero:	# Found Zero, we are done

	syscall			# Print the string

	pop	%rsi	# Restore registers from stack
	pop	%rdx	# In reverse order as we saved, stack is LIFO
	pop	%rcx
	pop	%rbx

	ret				# Return to where we came from

.data
hello:		.string "Hello World!\n"   # includes null at end
mystery:	.byte 63,0x3f,63,10,0      # mystery string
goodbye:	.string "Goodbye!\n"	   # includes null at end
